using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using Ctrip.Coach.Entity;
using System.Net;
using System.Text;
using System.IO;
using System.Web.Script.Serialization;
using Ctrip.Coach.SelfSer.Business.ShanDongJiNan.JNSer;

namespace Ctrip.Coach.SelfSer.Business.ShanDongJiNan
{
    public class JiNan : BusinessTemplate
    {
        //JNService.Service _ser=new JNService.Service();
        JNSer.Service _unionser = new JNSer.Service();

        private readonly GlobalConfig _configInfo = GlobalConfig.GetGlobalConfig();
        //private string Url = "http://123.232.98.196:9000/api/tkt";//
        private string Url = "http://192.168.160.183:9900/api/tkt";//"http://123.232.98.196:9001/api/tkt";//"http://192.168.160.185:9001/api/tkt";
        //http://123.232.98.196:9696/Service.asmx
        //http://123.232.98.196:7979/Service.asmx
        //վԽӿ"http://192.168.160.101/service.asmx";
        //MobilԽӿڵַ http://221.214.110.251:7979/Service.asmx
        string carrystaname = "";
        //1
        string operid = "";
        string token = "CDD29546399B8AF8C44038D0CD838DE9";
        string stationid = "1";//1վ 2 3վ 4ˮ 7վ(1006 1007 1008վ 1014001)
        string username="xiecheng";
        string password="xiecheng2015";
        //string encrypt = "@jnzz-jwct!";    
        //string _unionencrypt = "";
        //string unitname = "Я";
        private static int getTkType = 0;//ȡƱƱ 0ȡƱ 1Ʊ
        private List<Sch> listSch = new List<Sch>();
        Sch _curSch = new Sch();
        private List<BusStop> listbusstops = new List<BusStop>();
        public JiNan()
        {
        }
        public override void SelfDeviceLogin()
        {
            try
            {
                //վ 1007   
                //վ 1006
                carrystaname = GlobalConfig.GetGlobalConfig().Slefparams.Split('|')[0].ToString();//ʼվ
                stationid = GlobalConfig.GetGlobalConfig().Slefparams.Split('|')[1].ToString();//վ
                operid = GlobalConfig.GetGlobalConfig().Slefparams.Split('|')[2].ToString();//
                //Url = GlobalConfig.GetGlobalConfig().Slefparams.Split('|')[3].ToString();//ӿڵַ  
                _login();
            }
            catch {
                try
                {
                    System.Threading.Thread.Sleep(10000);
                    _login();
                }
                catch(Exception ex) { }
            }
            
        }
        bool hasEnoughBalaceValue()
        {
            try
            {
                string parmas = "{\"cmd\":2003,\"params\":{\"token\":"
        + "\"" + token + "\"" + "}}";
                Ctrip.IO.LogsWriter.WriteLogs("", "getBalaceValue-param" + parmas);
                string json = Post(Url, parmas);
                Ctrip.IO.LogsWriter.WriteLogs("", "getBalaceValue-json-" + json);
                string balancevalue = GetJsonNode(json, "data,balancevalue");
                if (int.Parse(balancevalue) < 1000)//֤1000ֹͣƱ
                {
                    return false;
                }
            }
            catch { }
            return true;
        }
        void _login()
        {
            string param = "{"
    + "\"cmd\":2001,"
    + "\"params\":{"
    + "\"username\":\"" + username + "\","
    + "\"password\":\"" + password + "\""
    + "}}";
            Ctrip.IO.LogsWriter.WriteLogs("","login-param-"+param);
            string json = Post(Url, param);
            Ctrip.IO.LogsWriter.WriteLogs("", "login-json-" + json);
            token = GetJsonNodeOrder(json,"data,token",',',0);
            Ctrip.IO.LogsWriter.WriteLogs("", "login-token-" + token);
        }
        
        public override string GetATMOper()
        {
            return operid;
        }
        /// <summary>
        /// ѯĿվ
        /// </summary>
        /// <param name="cityName"></param>
        /// <param name="carryStaName"></param>
        /// <returns></returns>
        public override List<BusStop> GetBusStops(string cityName, string carryStaName)
        {
            if (GlobalConfig.GetGlobalConfig().PayByUnion == "0" && GlobalConfig.GetGlobalConfig().PayByAlif2f == "0")
            {
                return base.GetBusStops(cityName, carryStaName);
            }
            string parmas = "{\"cmd\":3002,\"params\":{\"token\":"
                +"\""+token+"\""+",\"orgid\":"
            +stationid+",\"prtcode\":\"\",\"mode\":-1}}";
            //Ctrip.IO.LogsWriter.WriteLogs("", "getbusstop-param-" + parmas);
            string json = Post(Url, parmas);
            //Ctrip.IO.LogsWriter.WriteLogs("", "getbusstop-json-" + json);
            object[] objs = AnalyseJoson(json);          
            listbusstops = new List<BusStop>();
            foreach (object obj in objs)
            {
                Hashtable ht = new Hashtable();
                Dictionary<string, object> json_tk = (Dictionary<string, object>)obj;
                foreach (KeyValuePair<string, object> j in json_tk)
                {
                    ht.Add(j.Key, j.Value == null ? "" : j.Value.ToString());
                }
                BusStop bs = new BusStop();
                bs.StopName =ht["prtname"].ToString();

                bs.StopId = ht["prtid"].ToString();
                bs.PinYin = Hz2Py.Convert(bs.StopName);
                bs.Abbr = ht["prtcode"].ToString();
                listbusstops.Add(bs);
            }
            Ctrip.IO.LogsWriter.WriteLogs("", "GetBusStops-count-"+listbusstops.Count);
            return listbusstops;

        }
        string[] citylist = new string[] { };
        /// <summary>
        /// ·
        /// </summary>
        /// <returns></returns>
        public override string[] TopRoute()
        {
            //if (GlobalConfig.GetGlobalConfig().PayByUnion != "1")
            //    return base.TopRoute();
            if (citylist.Length > 0)
            {
                return citylist;
            }
            try
            {
                string parmas = "{\"cmd\":3009,\"params\":{\"token\":"
                    +"\""+token+"\""+",\"orgid\":"
           + stationid +"}}";
                Ctrip.IO.LogsWriter.WriteLogs("", "TopRoute-param-" + parmas);
                string json = Post(Url, parmas);
                Ctrip.IO.LogsWriter.WriteLogs("", "TopRoute-json-" + json);
                object[] objs = AnalyseJoson(json);
                citylist = new string[objs.Length];
                int i = 0;
                foreach (object obj in objs)
                {
                    Hashtable ht = new Hashtable();
                    Dictionary<string, object> json_tk = (Dictionary<string, object>)obj;
                    foreach (KeyValuePair<string, object> j in json_tk)
                    {
                        ht.Add(j.Key, j.Value == null ? "" : j.Value.ToString());
                    }
                    citylist[i] = ht["prtname"].ToString();
                    i++;
                }  
                return citylist;
            }
            catch
            {
                citylist = new string[] { };
                return citylist;
            }
        }
        private object[] AnalyseJoson(string jason)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            Dictionary<string, object> json = (Dictionary<string, object>)serializer.DeserializeObject(jason);
            object value;
            if (jason.ToString().Contains("result"))
            {
                json.TryGetValue("result", out value);//ɽӿֶcode
                if (value.ToString() != "1")
                {
                    json.TryGetValue("msg", out value);
                    throw new Exception(value.ToString());
                }
                json.TryGetValue("msg", out value);
                if (value.ToString() != "ɹ")
                {
                    throw new Exception(value.ToString());
                }

                json.TryGetValue("data", out value);
            }
            else
                json.TryGetValue("data", out value);
            object[] objs = (object[])value;
            return objs;
        }
        /// <summary>
        /// βѯ
        /// </summary>
        /// <param name="cityName"></param>
        /// <param name="stopName"></param>
        /// <param name="drvDate"></param>
        /// <returns></returns>
        public override List<Sch> GetSchPlan(string cityName, string stopName, string drvDate)
        {
            if (GlobalConfig.GetGlobalConfig().PayByUnion == "0" && GlobalConfig.GetGlobalConfig().PayByAlif2f == "0")
                return base.GetSchPlan(cityName, stopName, drvDate);
            BusStop busstop = listbusstops.Find(x => x.StopName == stopName);
            listSch = new List<Sch>();
            int portid = int.Parse(busstop.StopId);

            DateTime dt = DateTime.Parse(drvDate);
            long unixdt = Unix2DateTime.ConvertDateTime2Unix(dt);
            string parmas = "{\"cmd\":3003,\"params\":{\"token\":"
                +"\""+token+"\""+",\"orgid\":"
            +stationid+",\"prtid\":"
            +portid+ ",\"senddate\":"
                + unixdt + "}}";
            Ctrip.IO.LogsWriter.WriteLogs("", "GetSchPlan-param-" + parmas);
            string json = Post(Url, parmas);
            Ctrip.IO.LogsWriter.WriteLogs("", "GetSchPlan-json-" + json);
            object[] objs = AnalyseJoson(json);
          
            foreach (object obj in objs)
            {
                Hashtable ht = new Hashtable();
                Dictionary<string, object> json_tk = (Dictionary<string, object>)obj;
                foreach (KeyValuePair<string, object> j in json_tk)
                {
                    ht.Add(j.Key, j.Value == null ? "" : j.Value.ToString());
                }
                Sch sch = new Sch();
                sch.DrvDate = Unix2DateTime.ConvertInt2DateTime(long.Parse(ht["sendtime"].ToString())).ToString("yyyy-MM-dd");// schdetails[2];//
                sch.SchId = ht["id"].ToString();// schdetails[3];//κ
                sch.StartStaId = stationid;// schdetails[0];//ʼվ
                sch.StartStaName = carrystaname;// schdetails[1];//ʼվ
                sch.CarryStaId = stationid;// schdetails[0]; ;//վվ
                sch.CarryStaName = carrystaname;// schdetails[1];//վվ
                sch.StopId = portid.ToString();// schdetails[13];//վվ
                sch.StopName = ht["passengerportname"].ToString();// schdetails[14];//վվ
                sch.EndStopName = ht["endportname"].ToString();// schdetails[14];//յվ
                if (sch.StopName != sch.EndStopName)
                    sch.IsWayStation = true;
                sch.AllSeats = ht["cansellnum"].ToString();// schdetails[8];//λ
                sch.RouteName=ht["linename"].ToString();
                sch.OtherNeedInfo=ht["sellnum"].ToString();//Ʊ
                sch.EndStopId=ht["endportid"].ToString();
                //sch.RunTime = schdetails[17];//;ʱ
               
                sch.SeatRemain = (int.Parse(ht["cansellnum"].ToString())-int.Parse(ht["sellnum"].ToString())).ToString();// schdetails[7];//Ʊ
                sch.Children = "0";//ͯƱ
                sch.SaleChildForBid = true;
                sch.FullTkPrice = ht["price"].ToString();//schdetails[22];//ȫƱ
                //sch.OtherTkPrice = schinfo.PortStandradePrice.ToString();//Ʊ
                //sch.OtherTkPrice = ht["limit_price"].ToString() + "|" + ht["half_price"].ToString();//޼|ͯƱ
                //sch.OtherNeedInfo = schinfo.BliidStartNum.ToString();//ʼλ
                sch.Wicket = ht["checkwindow"].ToString();// schdetails[11]; ;//Ʊ
                sch.Remark = ht["buskindname"].ToString();// schdetails[15];//ȼ
                sch.SaleFlag = "1";//schdetails[26];               
                sch.BusType = ht["buskindname"].ToString();
                sch.DrvTime = Unix2DateTime.ConvertInt2DateTime(long.Parse(ht["sendtime"].ToString())).ToString("HH:mm"); //schdetails[4];//ʱ
                if (ht["isflow"].ToString().ToUpper() == "FALSE")
                {
                    sch.SchTypeId = "1";
                }
                else//ˮο 1 2 3 
                {
                    sch.SchTypeId = "2";
                    //ˮĻҪ»ȡ·ʱ                   
                    sch.FlowSchDrvTime = ht["flowinfo"].ToString().Replace('~','-');
                    try
                    {
                        sch.DrvTime = sch.FlowSchDrvTime.Split('-')[1];
                    }
                    catch { }
                }
                listSch.Add(sch);
            }  
            return listSch;
        }
        /// <summary>
        /// λ
        /// </summary>
        /// <param name="unionorder"></param>
        /// <returns></returns>
        public override List<Ticket> OrderLockSeats(OrderByUnion unionorder, out string error_result)
        {
            #region ֤
            //if (hasEnoughBalaceValue()==false)
            //{
            //    error_result = "֤ڷֵ޷";
            //    return new List<Ticket>();
            //}
            #endregion
            #region Ʊ֤
            string parmas = "{\"cmd\":3101,\"params\":{\"token\":\"07458BDC3A9AA4FAA1EAFC81FD248E10\",\"orgid\":"
            + stationid + ",\"employeeid\":"
            + operid
            + "}}";
            Ctrip.IO.LogsWriter.WriteLogs("", "ѯƱ-" + parmas);
            string json = Post(Url, parmas);
            Ctrip.IO.LogsWriter.WriteLogs("", "-" + json);
            string curtknum = "";
            try
            {
                curtknum = GetJsonNode(json, "data,usingno");
            }
            catch
            {                
                error_result = "ŶӦƱŻȡʧ";
                return new List<Ticket>();
            }
            GlobalConfig config = GlobalConfig.GetGlobalConfig();
            string curTk = config.CurTkNum;
            if (int.Parse(curtknum) != int.Parse(curTk))
            {
                error_result = "ǰƱ" + curTk + "̨Ʊ" + curtknum + "һ,޷";
                return new List<Ticket>();
            }
            #endregion
            List<Ticket> ListTicket = new List<Ticket>();
            try
            {               
                _curSch = listSch.Find(x => x.SchId == unionorder.Bus_Number);
                string isflow = "false";
                if (_curSch.SchTypeId == "1")
                {
                    isflow = "false";
                }
                else
                {
                    isflow = "true";
                }
                long sendtime = Unix2DateTime.ConvertDateTime2Long(DateTime.Parse(_curSch.DrvDate + " " + _curSch.DrvTime));
                error_result = "";
                string error = "";
                string busplan = "{"
                + "\"passengerportid\":"
                + _curSch.StopId + ",\"orgid\":"
                + stationid + ",\"endportname\":"
                    + "\"" + _curSch.EndStopName + "\"" + ",\"checkwindow\":"
                    + "\"" + _curSch.Wicket + "\"" + ",\"buskindname\":"
                   + "\"" + _curSch.BusType + "\"" + ",\"flowinfo\":"
                   + "\"" + _curSch.FlowSchDrvTime + "\"" + ",\"linename\":"
                      + "\"" + _curSch.RouteName + "\"" + ",\"isflow\":"
                + "\"" + isflow + "\"" + ",\"standardprice\":"
               + "\"" + _curSch.FullTkPrice + "\"" + ",\"id\":"
                + "\"" + _curSch.SchId + "\"" + ",\"passengerportname\":"
               + "\"" + _curSch.StopName + "\"" + ",\"orgname\":" //ϳ;վ 
              + "\"" + carrystaname + "\"" + ",\"sellnum\":"
                + _curSch.OtherNeedInfo + ",\"cansellnum\":"
                + _curSch.AllSeats + ",\"sendtime\":"
                + sendtime + ",\"endportid\":"
                + _curSch.EndStopId + ",\"price\":"
                + _curSch.FullTkPrice + "}";
                string customer = "{"
               + "\"name\": \"\","
               + "\"idcard\": {"
               + "\"idcardtype\": {"
                + "\"id\": 1,"
                + "\"name\": \"֤\""
                + "},"
                + "\"no\": \"\""
                + "},"
                + "\"address\": \"\","
                + "\"mobile\":" + "\"" + unionorder.Cus_Mobile + "\""
                 + "}";
               // string passenger = "{"
               //+ "\"name\": \"\","
               //+ "\"idcard\": {"
               //+ "\"idcardtype\": {"
               // + "\"id\": 1,"
               // + "\"name\": \"֤\""
               // + "},"
               // + "\"no\": \"\""
               // + "},"
               // + "\"address\": \"\","
               // + "\"mobile\": \"\""
               //  + "}";
               // string passengers = "";
               // for (int i = 0; i < unionorder.Ticket_Cnt; i++)
               // {
               //     passengers += passenger + ",";
               // }
                string passengers = "";
                foreach (UnionTicket ticket in unionorder.UnionTikcet)
                {
                    if (ticket.Identity_Code.Length != 18)
                    {
                        error_result = "֤" + ticket.Identity_Code + "λ,޷";
                        return new List<Ticket>();
                    }
                    passengers += "{"
                                  + "\"name\": \""+ticket.Identity_Name+"\","
                                  + "\"idcard\": {"
                                  + "\"idcardtype\": {"
                                   + "\"id\": 1,"
                                   + "\"name\": \""+ticket.Identity_Name+"\""
                                   + "},"
                                   + "\"no\": \"" + ticket .Identity_Code+ "\""
                                   + "},"
                                   + "\"address\": \"\","
                                   + "\"mobile\": \"\""
                                    + "},";
                }
                string passengers1 = passengers.Substring(0, passengers.Length - 1);//ȥ
                string passengers2 = "[" + passengers1 + "]";
                //string passengers = "[{\"idcard\":{\"id\":\"1\"},\"no\":\"\",\"mobile\":\"\"}]";

                string param = "{\"cmd\":3004,\"params\":{\"token\":"
                    + "\"" + token + "\"" + ","
                    + "\"busplan\":" + busplan
                    + ",\"ordertype\":1,\"customer\":"
                    + customer + ",\"passengers\":" + passengers2
                   + "}}";
                Ctrip.IO.LogsWriter.WriteLogs("", "OrderLockSeats-param:" + param);
                string orderno = "";
                string orderex = "";
                try
                {
                    json = Post(Url, param);
                    Ctrip.IO.LogsWriter.WriteLogs("", "OrderLockSeats:" + json);
                    orderno = GetJsonNode(json, "data,orderno");
                }
                catch
                {
                    error_result = json;
                    return new List<Ticket>();
                }
                try
                {
                    orderex = orderno.Substring(0, 2);
                }
                catch { }
                if (orderex.ToUpper() != "YD")
                {
                    error_result = json;
                    return new List<Ticket>();
                }
                parmas = "{\"cmd\":3007,\"params\":{\"token\":"
                    + "\"" + token + "\"" + ",\"orderno\":"
                + "\"" + orderno + "\"" + "}}";
                json = Post(Url, parmas);
                try
                {
                    for (int i = 0; i < unionorder.Ticket_Cnt; i++)//ӵڶʼΪλ
                    {
                        Ticket tk = new Ticket();
                        tk.OrderId = orderno;
                        tk.SeatNum = GetJsonNode(json, "data,detail,seatno", ',', i);
                        ListTicket.Add(tk);
                    }
                }
                catch
                {
                    error_result = "ȡλʧ";
                    return new List<Ticket>();
                }
                return ListTicket;
            }
            catch(Exception ex) {
                error_result = ex.Message;
                return ListTicket;
            }
          
        }
        public override DateTime GetServerTime()
        {
            string parmas = "{\"cmd\":1}";
            string json = Post(Url, parmas);
            string datetime = GetJsonNodeOrder(json, "data,datetime", ',', 0);
            DateTime dt = Unix2DateTime.ConvertInt2DateTime(long.Parse(datetime));
            return dt;
        }
        /// <summary>
        /// ͷλ
        /// </summary>
        /// <param name="unionorder"></param>
        /// <returns></returns>
        public override string OrderFreeSeats(OrderByUnion unionorder)
        {
            try
            {
               string parmas = "{\"cmd\":3006,\"params\":{\"token\":"
                   +"\""+token+"\""+",\"orderno\":"
            + unionorder.Vendor_Id + "}}";
                string json = Post(Url, parmas);
                Ctrip.IO.LogsWriter.WriteLogs("", "OrderFreeSeats:" + json);
                
            }
            catch { }
            return "1$" + "ȡɹ";
            //string param = computerid + "|" + stationid + "|" + unionorder.Vendor_Id + "|";
            //string str = unionser.CancelOrder(param);
            //Ctrip.IO.LogsWriter.WriteLogs("", "OrderFreeSeats:" + str);
            //switch (str)
            //{
            //    case "0":
            //        return "1$" + "ȡɹ";
            //    case "1":
            //        return "0$" + "ɹȡ";
            //    case "2":
            //        return "0$" + "ɹ֧֧δȡƱȡƱƱ";
            //    case "9":
            //        return "0$" + "δҵ¼綩Ŵ";
            //    default:
            //        return "0$δ֪,ȡʧ";
            //}
        }
        /// <summary>
        /// Ʊ
        /// </summary>
        /// <param name="unionorder"></param>
        /// <param name="error"></param>
        /// <returns></returns>
        public override List<Order> OrderApply(OrderByUnion unionorder, out string error_result)
        {
            getTkType = 1;//Ʊ
            error_result = "";
            string Error = "";
            List<Order> listorder = new List<Order>();
            List<Ticket> listticket = new List<Ticket>();
            try
            {
                string parmas = "{\"cmd\":3005,\"params\":{\"token\":"
                    + "\"" + token + "\"" + ",\"orderno\":"
                + "\"" + unionorder.Vendor_Id + "\"" + ",\"ordervalue\":"
                + unionorder.Total_Ticket_Fee + ",\"paymode\":4}}";
                string json = Post(Url, parmas);
                Ctrip.IO.LogsWriter.WriteLogs("", "OrderApply:" + json);
                AnalyseJoson(json);
                //ӡ
                foreach (UnionTicket unionticket in unionorder.UnionTikcet)
                {
                    long sendtime = Unix2DateTime.ConvertDateTime2Long(DateTime.Parse(unionorder.From_Date + " " + unionorder.From_Time));
                    long booktime = Unix2DateTime.ConvertDateTime2Long(DateTime.Now);
                    int isweb = 0;
                    int isself = 1;
                    parmas = "{\"cmd\":3103,\"params\":{\"token\":"
                        + "\"" + token + "\"" + ",\"orgid\":"
                    + stationid + ",\"employeeid\":"
                    + operid + ",\"orderno\":"
                    + "\"" + unionorder.Vendor_Id + "\"" + ",\"seatno\":"
                    + unionticket.Seat_Number + ",\"booktime\":"
                + booktime + ",\"sendtime\":"
                + sendtime + ",\"isself\":"
                + isself + ",\"isweb\":"
                + isweb
                + "}}";
                    Ctrip.IO.LogsWriter.WriteLogs("", "OrderApply-PrintTk-param-" + parmas);
                    json = Post(Url, parmas);
                    Ctrip.IO.LogsWriter.WriteLogs("", "OrderApply-PrintTk-json-" + json);
                    try
                    {
                        string result = GetJsonNode(json, "result");
                        if (result != "1")//ϵĽӿstring صȷOKOK ǴϢ
                        {
                            error_result = result;
                            return listorder;
                        }
                    }
                    catch (Exception ex) {
                        error_result = ex.Message;
                        return listorder; 
                    }
                }
                //
                int i = 0;
                foreach (UnionTicket unionticket in unionorder.UnionTikcet)
                {
                    Ticket tk = new Ticket();
                    tk.OrderId = unionorder.Vendor_Id;//ˮ
                    //tk.TicketId =ht["ticket_no"] == null ? "" : ht["ticket_no"].ToString();//Ʊ
                    tk.CarryStaName = unionorder.From_Station_Name;////ʼվ
                    tk.TicketStationAddr = unionorder.From_Station_Name;//ϳվ
                    tk.StopName = unionorder.To_City_Name; //վ
                    tk.SchId = unionorder.Bus_Number;//κ
                    tk.DrvTime = unionorder.From_Date + " " + unionorder.From_Time;//ʱ/
                    tk.BusType = unionorder.Bus_Type;//cllx_name
                    //tk.SchType = ht["cldj"] == null ? "" : ht["cldj"].ToString();//
                    //tk.MotName = ht["cydw"] == null ? "" : ht["cydw"].ToString();//˵λ
                    tk.TkTypeName = "ȫ";//ht["ticket_type"] == null ? "" : ht["ticket_type"].ToString();//Ʊ
                    tk.TkPrice = unionticket.Ticket_Full_Price;//Ʊ
                    tk.SeatNum = unionticket.Seat_Number;//λ
                    tk.Wicket = _curSch.Wicket;//ź
                    tk.EndAddress = _curSch.EndStopName;
                    tk.ChildInfo = unionorder.take_child_cnt.ToString();//ͯ
                    tk.Other3 = _curSch.OtherTkPrice;//Ʊ
                    tk.Other2 = _curSch.SchTypeId == "1" ? "FALSE" : "TRUE";
                    tk.TicketId = (Int64.Parse(GlobalConfig.GetGlobalConfig().CurTkNum) + i).ToString();
                    tk.CustomerId = unionticket.Identity_Code;
                    tk.CustomerName = unionticket.Identity_Name;
                    i++;
                    listticket.Add(tk);
                }
                ListTkToListOrder(listticket, listorder);
                return listorder;
            }
            catch(Exception ex)
            {
                error_result = ex.Message;
                return listorder;
            }
        }
        /// <summary>
        /// TicketToOrder
        /// </summary>
        /// <param name="list_tk"></param>
        /// <param name="list_order"></param>
        private void ListTkToListOrder(List<Ticket> list_tk, List<Order> list_order)
        {
            foreach (Ticket tk in list_tk)
            {
                Order order = new Order();
                order = list_order.Find(b => b.OrderId == tk.OrderId);
                if (order != null)
                {
                    order.TkAmount += 1;
                    order.SeatNums = "," + tk.SeatNum;
                    order.SumPrice = (decimal.Parse(order.SumPrice) + decimal.Parse(tk.TkPrice)).ToString();
                    continue;
                }
                order = new Order();
                order.StopName = tk.StopName;//վ
                order.TkPrice = tk.TkPrice;//Ʊ
                order.DrvTime = tk.DrvTime;//ʱ
                order.SchId = tk.SchId;//κ
                order.SeatNums = tk.SeatNum;//λ
                order.TkAmount = 1;//Ʊ
                order.SumPrice = tk.TkPrice;//Ʊ
                order.OrderId = tk.OrderId;//
                order.CarryStaName = tk.CarryStaName;//ʼվ
                order.Wicket = tk.Wicket;
                list_order.Add(order);
            }
            foreach (Order order in list_order)
            {
                order.OrderTickets = list_tk.FindAll(t => t.OrderId == order.OrderId);
            }
        }
        /// <summary>
        /// ݿվõȡƱʽ
        /// </summary>
        /// <param name="carrySta">վ</param>
        /// <returns>ȡƱʽ0 + 1  2룩ű</returns>
        public override string GetTkByKeyType(string carrySta)
        {
            return "0|֤|ȡƱ";
        }

        public override string GetNextTkNum(string startTkNum, string endTkNum, string curTkNum)
        {
            Int64 curNum = Int64.Parse(curTkNum);
            curNum = curNum + 1;
            return curNum.ToString("00000000");
        }

        public override int GetTkRangeRemain(string startTkNum, string endTkNum, string curTkNum)
        {
            if (curTkNum.Length != 8 || endTkNum.Length != 8)
                return -1;
            if (curTkNum.Length * endTkNum.Length == 0)
                return -1;
            Int64 curNum = Int64.Parse(curTkNum);
            Int64 endNum = Int64.Parse(endTkNum);
            return Convert.ToInt32(endNum - curNum+1);
        }
        public override List<Order> GetOrdersByKey(string getTkNum, string keys)
        {
            getTkType = 0;
            //|ȡƱ|ȡƱ|֤|绰|ȡƱ
            //OrderNumber|FetcherCode|FetcherPassword|FetcherPaperNum|ContactMobile|FetcherWebsiteOrderNumber
            //return orderId + "|" + getTkNum + "|" + getTkKey + "|" + cusId + "|" + phone + "|" + webNumber;
            //getTkNum = "orderid|tt|tt|130182198412201454|tt|55";
            if (getTkNum.Split('|').Length > 5)//ʱֻ֤ȡƱȡһɨ֧ȡ֤ϢӡƱ
            {
                keys = getTkNum.Split('|')[2];
                getTkNum = getTkNum.Split('|')[3];
                //1 ȡһ֤Ϣ ҪĲ  
                //2 ݶŲѯϢcount>1,ȡ
                string orderno = "";
                string parmas = "{\"cmd\":3102,\"params\":{\"token\":"
                    + "\"" + token + "\"" + ",\"orgid\":"
                + stationid + ",\"idcard\":{\"idcardtype\":{\"id\":1,\"name\":\"֤\"},\"no\":"
                + "\"" + getTkNum + "\"" + "}}}";
                Ctrip.IO.LogsWriter.WriteLogs("", "getorderbycusid-parmas-" + parmas);
                string json = Post(Url, parmas);
                Ctrip.IO.LogsWriter.WriteLogs("", "getorderbycusid-json-" + json);
                object[] objs = AnalyseJoson(json);
                int count = objs.Length;
                List<Order> listResult = new List<Order>();
                List<Order> listResultFromOrder = new List<Order>();
                Ticket tickettmplete = new Ticket();
                for (int i = 0; i < count; i++)
                {
                    if (GetJsonNodeOrder(json, "data,state", ',', i) != "1")// 0Ԥ1֧2ȡ3Ѵӡ
                    {
                        continue;
                    }
                    if (GetJsonNodeOrder(json, "data,insuranceprice", ',', i) != "0")
                        throw new Exception("ѹ뵽˹ȡƱ");

                    Ticket ticket = new Ticket();
                    tickettmplete.OrderId=orderno = ticket.OrderId = GetJsonNodeOrder(json, "data,ordno", ',', i);
                    if (stationid == "1014001")
                    {
                        tickettmplete.CarryStaName = ticket.CarryStaName = ""; 
                    }
                    else
                    {
                        tickettmplete.CarryStaName = ticket.CarryStaName = "";
                    }
                    

                    tickettmplete.DrvTime = ticket.DrvTime = Unix2DateTime.ConvertInt2DateTime(long.Parse(GetJsonNodeOrder(json, "data,busplan,sendtime", ',', i))).ToString("yyyy-MM-dd HH:mm");//unixתdatetime
                    tickettmplete.StopName = ticket.StopName = GetJsonNodeOrder(json, "data,busplan,passengerportname", ',', i);
                    tickettmplete.EndAddress = ticket.EndAddress = GetJsonNodeOrder(json, "data,busplan,endportname", ',', i);
                    tickettmplete.SchId = ticket.SchId = GetJsonNodeOrder(json, "data,busplan,id", ',', i);
                    tickettmplete.TkPrice = ticket.TkPrice = GetJsonNodeOrder(json, "data,buyprice", ',', i);
                    //ticket.CustomerId = lists[i].CustomIDCard;
                    //ticket.Other3 = lists[i].StandradePrice.ToString();//Ʊ
                    tickettmplete.Wicket = ticket.Wicket = GetJsonNodeOrder(json, "data,busplan,checkwindow", ',', i);

                    tickettmplete.SellTkTime = ticket.SellTkTime = GetJsonNodeOrder(json, "data,booktime", ',', i);//µʱ unixʽ
                    tickettmplete.Other1 = ticket.Other1 = GetJsonNodeOrder(json, "data,busplan,sendtime", ',', i);//ʱ unixʽ
                    tickettmplete.Other3 = ticket.Other3 = GetJsonNodeOrder(json, "data,isweb", ',', i);//Ƿ
                    tickettmplete.Other4 = ticket.Other4 = GetJsonNodeOrder(json, "data,isself", ',', i);//Ƿ

                    tickettmplete.Other2 = ticket.Other2 = GetJsonNodeOrder(json, "data,busplan,isflow", ',', i).ToUpper();//trueΪˮ FalseΪˮ
                    tickettmplete.SeatNum = ticket.SeatNum = GetJsonNodeOrder(json, "data,seatno", ',', i);
                    try
                    {
                        ticket.CustomerId = GetJsonNodeOrder(json, "data,passenger,idcard,no", ',', i);
                        Ctrip.IO.LogsWriter.WriteLogs("",ticket.CustomerId);
                        ticket.CustomerName = GetJsonNodeOrder(json, "data,passenger,name", ',', i);
                        Ctrip.IO.LogsWriter.WriteLogs("", ticket.CustomerName);
                    }
                    catch (Exception ex) { Ctrip.IO.LogsWriter.WriteLogs("",ex.Message); }
                    string discountrate = GetJsonNodeOrder(json, "data,discountrate", ',', i);
                    if (discountrate == "50")
                    {
                        ticket.TkTypeName = "";
                    }
                    else if (discountrate != "0")
                    {
                        ticket.TkTypeName = "";
                    }
                    else
                        ticket.TkTypeName = "ȫ";
                    tickettmplete.TkTypeName = ticket.TkTypeName;
                    bool isExit = false;
                    string getTicketId = ticket.OrderId;
                    foreach (var orderResult in listResult)
                    {
                        if (orderResult.OrderId == getTicketId)
                        {
                            orderResult.TkAmount++;
                            orderResult.SumPrice = (Convert.ToDouble(orderResult.SumPrice) + Convert.ToDouble(ticket.TkPrice)).ToString("0.00");

                            orderResult.OrderTickets.Add(ticket);
                            isExit = true;
                        }
                    }
                    if (isExit == false)
                    {
                        Order order = new Order();
                        order.OrderId = ticket.OrderId;
                        order.CarryStaName = ticket.CarryStaName;
                        order.DrvTime = ticket.DrvTime;
                        order.StopName = ticket.StopName;
                        order.SchId = ticket.SchId;
                        order.TkAmount = 1;
                        order.SumPrice = order.TkPrice = ticket.TkPrice;
                        List<Ticket> listtk = new List<Ticket>();
                        listtk.Add(ticket);
                        order.OrderTickets = listtk;

                        listResult.Add(order);
                    }
                }
                //ݶŻȡϢ
                parmas = "{\"cmd\":3007,\"params\":{\"token\":"
               + "\"" + token + "\"" + ",\"orderno\":"
           + "\"" + orderno + "\"" + "}}";
                json = Post(Url, parmas);
                Ctrip.IO.LogsWriter.WriteLogs("","GetOrder-"+json);
                try
                {
                    int ticketcount=int.Parse(GetJsonNode(json, "data,count", ',', 0));
                    if (ticketcount > 1)
                    {
                        for (int i = 0; i < ticketcount; i++)
                        {
                            Ticket tk = new Ticket();
                            tk.SeatNum = GetJsonNode(json, "data,detail,seatno", ',', i);
                            try
                            {
                                tk.CustomerId = GetJsonNodeIdCard(json, "data,detail,passenger,idcard,no", ',', i);
                                Ctrip.IO.LogsWriter.WriteLogs("", tk.CustomerId);
                                tk.CustomerName = GetJsonNodeIdCard(json, "data,detail,passenger,name", ',', i);
                                Ctrip.IO.LogsWriter.WriteLogs("", tk.CustomerName);
                            }
                            catch (Exception ex) { Ctrip.IO.LogsWriter.WriteLogs("",ex.Message); }
                            //Ctrip.IO.LogsWriter.WriteLogs("", "SeatNum:"+tk.SeatNum);
                            tk.OrderId = tickettmplete.OrderId;
                            //Ctrip.IO.LogsWriter.WriteLogs("", "OrderId:"+tk.OrderId);
                            if (stationid == "1014001")
                            {
                                tk.CarryStaName = "";
                            }
                            else
                            {
                                tk.CarryStaName = "";
                            }
                            tk.DrvTime = tickettmplete.DrvTime;
                            //Ctrip.IO.LogsWriter.WriteLogs("", "DrvTime:"+tk.DrvTime);
                            tk.StopName = tickettmplete.StopName;
                            //Ctrip.IO.LogsWriter.WriteLogs("","StopName:"+ tk.StopName);
                            tk.SchId = tickettmplete.SchId;
                            //Ctrip.IO.LogsWriter.WriteLogs("","SchId:"+ tk.SchId);
                            tk.TkPrice = tickettmplete.TkPrice;
                            //Ctrip.IO.LogsWriter.WriteLogs("","TkPrice:"+ tk.TkPrice);
                            tk.Wicket = tickettmplete.Wicket;
                            //Ctrip.IO.LogsWriter.WriteLogs("", "Wicket:"+tk.Wicket);
                            tk.SellTkTime = tickettmplete.SellTkTime;//µʱ unixʽ
                           // Ctrip.IO.LogsWriter.WriteLogs("","SellTkTime:"+ tk.SellTkTime);
                            tk.Other1 = tickettmplete.Other1;//ʱ unixʽ
                            //Ctrip.IO.LogsWriter.WriteLogs("","Other1:"+ tk.Other1);
                            tk.Other3 = tickettmplete.Other3;//Ƿ
                            //Ctrip.IO.LogsWriter.WriteLogs("","Other3:"+ tk.Other3);
                            tk.Other4 = tickettmplete.Other4;//Ƿ
                            //Ctrip.IO.LogsWriter.WriteLogs("","Other4:"+ tk.Other4);
                            tk.Other2 = tickettmplete.Other2;//trueΪˮ FalseΪˮ   
                           // Ctrip.IO.LogsWriter.WriteLogs("","Other2:"+ tk.Other2);
                            tk.TkTypeName = tickettmplete.TkTypeName;
                            tk.EndAddress = tickettmplete.EndAddress;
                            //Ctrip.IO.LogsWriter.WriteLogs("", "TkTypeName:" + tk.TkTypeName);
                            bool isExit = false;
                            string getTicketId = tk.OrderId;
                            foreach (var orderResult in listResultFromOrder)
                            {
                                if (orderResult.OrderId == getTicketId)
                                {
                                    orderResult.TkAmount++;
                                    orderResult.SumPrice = (Convert.ToDouble(orderResult.SumPrice) + Convert.ToDouble(tk.TkPrice)).ToString("0.00");

                                    orderResult.OrderTickets.Add(tk);
                                    isExit = true;
                                }
                            }
                            if (isExit == false)
                            {
                                Order order = new Order();
                                order.OrderId = tk.OrderId;
                                order.CarryStaName = tk.CarryStaName;
                                order.DrvTime = tk.DrvTime;
                                order.StopName = tk.StopName;
                                order.SchId = tk.SchId;
                                order.TkAmount = 1;
                                order.SumPrice = order.TkPrice = tk.TkPrice;
                                List<Ticket> listtk = new List<Ticket>();
                                listtk.Add(tk);
                                order.OrderTickets = listtk;

                                listResultFromOrder.Add(order);
                            }

                        }
                        return listResultFromOrder;
                    }
                    else
                    {
                        return listResult;
                    }
                }
                catch
                {
                    return listResult;
                }
                return listResult;
                //return GetOrdersByCustomerId(getTkNum);
            }
            //return GetOrdersByCustomerId(getTkNum);
            return new List<Order>();
        }
        
        public static string GetJsonNode(string json, string node)
        {
            return GetJsonNode(json, node, ',', 0);
        }
        public static string GetJsonNode(string json, string node, int num)
        {
            return GetJsonNode(json, node, ',', num);
        }
        public static string GetJsonNodeIdCard(string json, string node, char splideChar, int num)
        {
            string node_result = "";
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            object value;
            string node_name = "";
            Dictionary<string, object> json_nodes = (Dictionary<string, object>)serializer.DeserializeObject(json);
            int count = 0;
            foreach (string node_ch in node.Split(splideChar))
            {
                count++;
                node_name = node_ch;
                try
                {
                    json_nodes.TryGetValue(node_name, out value);

                    node_result = value == null ? "" : value.ToString();

                    if (node_result == "System.Object[]")
                    {
                        if (node_name == "data")
                        {
                            json_nodes = (Dictionary<string, object>)(((System.Object[])value)[0]);
                        }
                        else
                        {
                            json_nodes = (Dictionary<string, object>)(((System.Object[])value)[num]);
                        }
                    }
                    else
                    {
                        if (count < node.Split(splideChar).Length)
                            json_nodes = (Dictionary<string, object>)value;
                    }
                }
                catch
                {
                    return "";
                }
            }
            return node_result;
        }
        public static string GetJsonNode(string json, string node, char splideChar, int num)
        {
            string node_result = "";
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            object value;
            string node_name = "";
            Dictionary<string, object> json_nodes = (Dictionary<string, object>)serializer.DeserializeObject(json);
            int count = 0;
            foreach (string node_ch in node.Split(splideChar))
            {
                count++;
                node_name = node_ch;
                try
                {
                    json_nodes.TryGetValue(node_name, out value);

                    node_result = value == null ? "" : value.ToString();

                    if (node_result == "System.Object[]")
                    {
                        if (node_name == "data")
                        {
                            json_nodes = (Dictionary<string, object>)(((System.Object[])value)[0]);
                        }
                        else
                        {
                            json_nodes = (Dictionary<string, object>)(((System.Object[])value)[num]);
                        }
                    }
                    else
                    {
                        if (count < node.Split(splideChar).Length)
                            json_nodes = (Dictionary<string, object>)value;
                    }
                }
                catch
                {
                    return "";
                }
            }
            return node_result;
        }
        public static string GetJsonNodeOrder(string json, string node, char splideChar, int num)
        {
            string node_result = "";
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            object value;
            string node_name = "";
            Dictionary<string, object> json_nodes = (Dictionary<string, object>)serializer.DeserializeObject(json);
            int count = 0;
            foreach (string node_ch in node.Split(splideChar))
            {
                count++;
                node_name = node_ch;
                try
                {
                    json_nodes.TryGetValue(node_name, out value);

                    node_result = value == null ? "" : value.ToString();

                    if (node_result == "System.Object[]")
                    {                        
                        
                        {
                            json_nodes = (Dictionary<string, object>)(((System.Object[])value)[num]);
                        }
                    }
                    else
                    {
                        if (count < node.Split(splideChar).Length)
                            json_nodes = (Dictionary<string, object>)value;
                    }
                }
                catch
                {
                    return "";
                }
            }
            return node_result;
        }
        private object[] AnalyseJosonIdCard(string jason)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            Dictionary<string, object> json = (Dictionary<string, object>)serializer.DeserializeObject(jason);
            object value;
            if (jason.ToString().Contains("result"))
            {
                json.TryGetValue("result", out value);//ɽӿֶcode
                if (value.ToString() != "1")
                {
                    json.TryGetValue("msg", out value);
                    throw new Exception(value.ToString());
                }
                json.TryGetValue("msg", out value);
                if (value.ToString() != "ɹ")
                {
                    throw new Exception(value.ToString());
                }

                json.TryGetValue("data", out value);
            }
            else
                json.TryGetValue("data", out value);
            object[] objs = (object[])value;
            return objs;
        }
        public override List<Order> GetOrdersByCustomerId(string cusId)
        {
            getTkType = 0;
            string parmas = "{\"cmd\":3102,\"params\":{\"token\":"
                +"\""+token+"\""+",\"orgid\":"
            + stationid + ",\"idcard\":{\"idcardtype\":{\"id\":1,\"name\":\"֤\"},\"no\":"
            + "\""+cusId+"\"" + "}}}";
            Ctrip.IO.LogsWriter.WriteLogs("", "getorderbycusid-parmas-" + parmas);
            string json = Post(Url, parmas);
            Ctrip.IO.LogsWriter.WriteLogs("", "getorderbycusid-json-" + json);
            object[] objs=null;
            if (stationid == "1007")
            {              
                try
                {
                    objs = AnalyseJosonIdCard(json);
                }
                catch {
                    parmas = "{\"cmd\":3102,\"params\":{\"token\":"
                + "\"" + token + "\"" + ",\"orgid\":"
            + "1006" + ",\"idcard\":{\"idcardtype\":{\"id\":1,\"name\":\"֤\"},\"no\":"
            + "\"" + cusId + "\"" + "}}}";
                    Ctrip.IO.LogsWriter.WriteLogs("", "getorderbycusid-parmas-" + parmas);
                    json = Post(Url, parmas);
                    Ctrip.IO.LogsWriter.WriteLogs("", "getorderbycusid-json-" + json);

                    objs = AnalyseJosonIdCard(json);
                    if (objs.Length > 0)
                    {
                        throw new Exception("ƱΪƱ,뵽ȡƱ˳");
                    }
                }

            }
            else
            {
                objs = AnalyseJoson(json);
            }
            int count = objs.Length;
            List<Order> listResult = new List<Order>();
            for (int i = 0; i < count; i++)
            {
                if (GetJsonNodeOrder(json, "data,state",',', i) != "1")// 0Ԥ1֧2ȡ3Ѵӡ
                {
                    continue;
                }
                if (GetJsonNodeOrder(json, "data,insuranceprice", ',', i) != "0")
                    throw new Exception("ѹ뵽˹ȡƱ");
                
                Ticket ticket = new Ticket();
                ticket.OrderId = GetJsonNodeOrder(json, "data,ordno", ',', i);
                if (stationid == "1014001")
                {
                    ticket.CarryStaName = "";
                }
                else
                {
                    ticket.CarryStaName = "";
                }
                ticket.DrvTime = Unix2DateTime.ConvertInt2DateTime(long.Parse(GetJsonNodeOrder(json, "data,busplan,sendtime", ',', i))).ToString("yyyy-MM-dd HH:mm");//unixתdatetime
                ticket.StopName = GetJsonNodeOrder(json, "data,busplan,passengerportname", ',', i);
                ticket.EndAddress = GetJsonNodeOrder(json, "data,busplan,endportname", ',', i);
                ticket.SchId = GetJsonNodeOrder(json, "data,busplan,id", ',', i);
                ticket.TkPrice = GetJsonNodeOrder(json, "data,buyprice", ',', i);
                //ticket.CustomerId = lists[i].CustomIDCard;
                //ticket.Other3 = lists[i].StandradePrice.ToString();//Ʊ
                ticket.Wicket = GetJsonNodeOrder(json, "data,busplan,checkwindow", ',', i);

                ticket.SellTkTime = GetJsonNodeOrder(json, "data,booktime", ',', i);//µʱ unixʽ
                ticket.Other1 = GetJsonNodeOrder(json, "data,busplan,sendtime", ',', i);//ʱ unixʽ
                ticket.Other3 = GetJsonNodeOrder(json, "data,isweb", ',', i);//Ƿ
                ticket.Other4 = GetJsonNodeOrder(json, "data,isself", ',', i);//Ƿ

                ticket.Other2 = GetJsonNodeOrder(json, "data,busplan,isflow", ',', i).ToUpper();//trueΪˮ FalseΪˮ
                ticket.SeatNum = GetJsonNodeOrder(json, "data,seatno", ',', i);
                try
                {
                    ticket.CustomerId = GetJsonNodeOrder(json, "data,passenger,idcard,no", ',', i);//ûdetail
                    ticket.CustomerName = GetJsonNodeOrder(json, "data,passenger,name", ',', i);
                }
                catch { }
                string discountrate = GetJsonNodeOrder(json, "data,discountrate", ',', i);
                if (discountrate == "50")
                {
                    ticket.TkTypeName = "";
                }
                else if (discountrate != "0")
                {
                    ticket.TkTypeName = "";
                }
                else
                    ticket.TkTypeName = "ȫ";               
                bool isExit = false;
                string getTicketId = ticket.OrderId;
                foreach (var orderResult in listResult)
                {
                    if (orderResult.OrderId == getTicketId)
                    {
                        orderResult.TkAmount++;
                        orderResult.SumPrice = (Convert.ToDouble(orderResult.SumPrice) + Convert.ToDouble(ticket.TkPrice)).ToString("0.00");

                        orderResult.OrderTickets.Add(ticket);
                        isExit = true;
                    }
                }
                if (isExit == false)
                {
                    Order order = new Order();
                    order.OrderId = ticket.OrderId;
                    order.CarryStaName = ticket.CarryStaName;
                    order.DrvTime = ticket.DrvTime;
                    order.StopName = ticket.StopName;
                    order.SchId = ticket.SchId;
                    order.TkAmount = 1;
                    order.SumPrice = order.TkPrice = ticket.TkPrice;
                    List<Ticket> listtk = new List<Ticket>();
                    listtk.Add(ticket);
                    order.OrderTickets = listtk;

                    listResult.Add(order);
                }
            }
            return listResult;
        }

        public override List<TicketRange> GetTkRange()
        {
            List<TicketRange> ticrange = new List<TicketRange>();
            string parmas = "{\"cmd\":3101,\"params\":{\"token\":"
                + "\"" + token + "\"" + ",\"orgid\":"
            + stationid + ",\"employeeid\":"
            + operid
            + "}}";
            Ctrip.IO.LogsWriter.WriteLogs("", "ѯƱ-" + parmas);
            string json = Post(Url, parmas);
            Ctrip.IO.LogsWriter.WriteLogs("", "-" + json);           
            try
            {
                 TicketRange range = new TicketRange();
                range.CurTkId = GetJsonNode(json, "data,usingno"); 
                range.StartTkId = GetJsonNode(json, "data,startno");
                range.EndTkId = GetJsonNode(json, "data,endno");
                ticrange.Add(range);
            }
            catch
            {
                throw new Exception("ŶӦƱŻȡʧ");
            } 
            return ticrange;
        }

        public override bool CheckTkNumConsistency(out string result)
        {
            result = "";
            getTkType = 0;
            string parmas = "{\"cmd\":3101,\"params\":{\"token\":"
                +"\""+token+"\""+",\"orgid\":"
            +stationid+",\"employeeid\":"
            +operid
            +"}}";
            Ctrip.IO.LogsWriter.WriteLogs("","ѯƱ-"+parmas);
            string json = Post(Url, parmas);
            Ctrip.IO.LogsWriter.WriteLogs("", "-" + json);
            string curtknum="";
            try
            {
                curtknum = GetJsonNode(json, "data,usingno");
            }
            catch {
                result="ŶӦƱŻȡʧ";
                return false;
            }
            GlobalConfig config = GlobalConfig.GetGlobalConfig();
            string curTk = config.CurTkNum;
            if (int.Parse(curtknum) != int.Parse(curTk))
            {
                result = "̨Ʊ" + curtknum + "һ";
                return false;
            }
            return true;
        }
        public override bool PrePrintTicket(Ticket tk)
        {
            getTkType = 0;
            string parmas = "{\"cmd\":3101,\"params\":{\"token\":"
                +"\""+token+"\""+",\"orgid\":"
            +stationid+",\"employeeid\":"
            +operid
            +"}}";
            Ctrip.IO.LogsWriter.WriteLogs("","ѯƱ-"+parmas);
            string json = Post(Url, parmas);
            Ctrip.IO.LogsWriter.WriteLogs("", "-" + json);
            string curtknum="";
            try
            {
                curtknum = GetJsonNode(json, "data,usingno");
            }
            catch {
                throw new Exception("ŶӦƱŻȡʧ");
            }
            GlobalConfig config = GlobalConfig.GetGlobalConfig();
            string curTk = config.CurTkNum;
            if (int.Parse(curtknum)!= int.Parse(curTk))
            {
                throw new Exception("ǰƱ" + curTk + "̨Ʊ" + curtknum + "һ,ӡʧ");
            }
            parmas = "{\"cmd\":3103,\"params\":{\"token\":"
                +"\""+token+"\""+",\"orgid\":"
            +stationid+",\"employeeid\":"
            +operid+",\"orderno\":"
            +"\""+tk.OrderId+"\""+",\"seatno\":"
            +tk.SeatNum+",\"booktime\":"
            +tk.SellTkTime+",\"sendtime\":"
            +tk.Other1+",\"isself\":"
            +tk.Other4+",\"isweb\":"
            +tk.Other3
            +"}}";
            Ctrip.IO.LogsWriter.WriteLogs("", "PrintTk-param-" + parmas);
            json = Post(Url, parmas);
            Ctrip.IO.LogsWriter.WriteLogs("", "PrintTk-json-" + json);            
            try
            {
                string result = GetJsonNode(json, "result");
                if (result!= "1")//ϵĽӿstring صȷOKOK ǴϢ
                {
                    throw new Exception(result);
                }
                tk.TicketId = curTk;
            }
            catch (Exception ex) { throw ex; }
            return true;
        }

        public override string GetNote1Name()
        {
            return "sdjn.note";
        }

        public override string GetNote2Name()
        {
            return GetNote1Name();
        }

        public override string GetLog(string orderid, string ticketnum, Hashtable ht)
        {
            string logs = string.Format("ӡƱ|{0}|{1}|{2}|{3}|{4}|{5}|{6}|{7}|{8}|{9}|{10}|{11}|{12}|{13}",
                        orderid, ticketnum,
            ht["SeatNum"], ht["TkTypeName"], ht["BusType"], ht["CarryStaName"], ht["StopName"],
            ht["SchId"], ht["DrvDate"], ht["DrvTime"], ht["UserId"], ht["MotName"], ht["TkPrice"],
            ht["Wicket"]);
            return logs;
        }

        public override Hashtable GetTkPrintInfo(Ticket tk)
        {
            var ht = new Hashtable();
            try
            {
                ht["CarryStaName"] = "(" + carrystaname + ")";
                ht["StopName"] = tk.StopName;
                if (!string.IsNullOrEmpty(tk.EndAddress))//·
                {
                    if (tk.EndAddress != tk.StopName)
                    {
                        ht["StopName"] = tk.StopName + "(·|յվ:"+tk.EndAddress+")";
                    }
                }
                ht["TkPrice"] = Double.Parse(tk.TkPrice).ToString("0.0");
                //ht["HighPrice"] = Double.Parse(tk.Other3).ToString("0.0");
                ht["TkTypeName"] = tk.TkTypeName;
                ht["TkTypeName1"] = "(" + tk.TkTypeName.Substring(0, 1) + ")";

                ht["DrvDate"] = DateTime.Parse(tk.DrvTime).ToString("yyyy-MM-dd");
                ht["pDrvDate"] = DateTime.Parse(tk.DrvTime).ToString("yyyyMMdd");
                ht["OperId"] = operid;//ӡƱʱʹõĹ
                ht["SchId"] = tk.SchId;
                if (tk.Other2 == "TRUE")
                {
                    ht["DrvTime"] = "ˮ";
                    ht["SeatNum"] = "ˮ";
                }
                else
                {
                    ht["DrvTime"] = DateTime.Parse(tk.DrvTime).ToString("HH:mm");
                    ht["SeatNum"] = tk.SeatNum;
                }
                ht["TicketId"] = operid + "-" + tk.TicketId;
                ht["TicketId1"] = operid + "-" + tk.TicketId + "-" + ht["SeatNum"];
                ht["Wicket"] = tk.Wicket;
                DateTime dt = DateTime.Now;
                ht["PrintDate"] = dt.ToString("MM-dd");
                ht["PrintTime"] = "(" + dt.ToString("HH:mm") + ")";
                ht["PrintDateAndTime"] = dt.ToString("MM-dd HH:mm");
                try
                {
                    ht["CusName"] = tk.CustomerName;
                    string cusid = tk.CustomerId;
                    ht["CusId"] = cusid.Substring(0,10)+"****"+cusid.Substring(cusid.Length-4,4);
                }
                catch { }
                if (getTkType == 0)//ȡƱ
                    ht["Note"] = "";
                else
                    ht["Note"] = "Я";
            }
            catch (Exception ex) { Ctrip.IO.LogsWriter.WriteLogs("", ex.ToString()); }
            return ht;
        }

        internal string Post(string url, string param)
        {
            //Encoding myEncoding = Encoding.GetEncoding("utf-8");
            // param = HttpUtility.UrlEncode(param, myEncoding);

            HttpWebRequest req = (HttpWebRequest)WebRequest.Create(url);
            byte[] requestBytes = System.Text.Encoding.UTF8.GetBytes(param);
            req.Method = "POST";
            req.ContentType = "application/json;charset=utf-8";//"application/x-www-form-urlencoded";"text/html;charset=UTF-8";// 
            req.ContentLength = requestBytes.Length;
            Stream requestStream = req.GetRequestStream();
            requestStream.Write(requestBytes, 0, requestBytes.Length);
            requestStream.Close();

            HttpWebResponse res = (HttpWebResponse)req.GetResponse();
            StreamReader streamReader = new StreamReader(res.GetResponseStream(), System.Text.Encoding.UTF8);
            String jason = streamReader.ReadToEnd();
            streamReader.Close();
            return jason;
        }
    }
}